diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/gcr-group-address.cc ns-3.45/src/wifi/model/gcr-group-address.cc
--- ns-3.44/src/wifi/model/gcr-group-address.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/gcr-group-address.cc	2025-06-01 20:34:45.616702300 -0700
@@ -16,7 +16,7 @@
 void
 GcrGroupAddress::Print(std::ostream& os) const
 {
-    os << "gcrGroupAddress=" << m_gcrGroupAddress;
+    os << "GCR Group Address=[" << m_gcrGroupAddress << "]";
 }
 
 WifiInformationElementId
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-6ghz-band-capabilities.cc ns-3.45/src/wifi/model/he/he-6ghz-band-capabilities.cc
--- ns-3.44/src/wifi/model/he/he-6ghz-band-capabilities.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-6ghz-band-capabilities.cc	2025-06-01 20:34:45.616702300 -0700
@@ -124,14 +124,14 @@
 void
 He6GhzBandCapabilities::Print(std::ostream& os) const
 {
-    os << "HE 6GHz Band Capabilities=[Capabilities Information|"
-       << " Min MPDU start spacing: " << +m_capabilitiesInfo.m_minMpduStartSpacing
-       << " Max A-MPDU Length Exp: " << +m_capabilitiesInfo.m_maxAmpduLengthExponent
-       << " Max MPDU Length: " << +m_capabilitiesInfo.m_maxMpduLength
-       << " SM Power Save: " << +m_capabilitiesInfo.m_smPowerSave
-       << " RD Responder: " << +m_capabilitiesInfo.m_rdResponder
-       << " RX Antenna Pattern: " << +m_capabilitiesInfo.m_rxAntennaPatternConsistency
-       << " TX Antenna Pattern: " << +m_capabilitiesInfo.m_txAntennaPatternConsistency << "]";
+    os << "HE 6GHz Band Capabilities=["
+       << "Min MPDU start spacing: " << +m_capabilitiesInfo.m_minMpduStartSpacing
+       << ", Max A-MPDU Length Exp: " << +m_capabilitiesInfo.m_maxAmpduLengthExponent
+       << ", Max MPDU Length: " << +m_capabilitiesInfo.m_maxMpduLength
+       << ", SM Power Save: " << +m_capabilitiesInfo.m_smPowerSave
+       << ", RD Responder: " << +m_capabilitiesInfo.m_rdResponder
+       << ", RX Antenna Pattern: " << +m_capabilitiesInfo.m_rxAntennaPatternConsistency
+       << ", TX Antenna Pattern: " << +m_capabilitiesInfo.m_txAntennaPatternConsistency << "]";
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-capabilities.cc ns-3.45/src/wifi/model/he/he-capabilities.cc
--- ns-3.44/src/wifi/model/he/he-capabilities.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-capabilities.cc	2025-06-01 20:34:45.616702300 -0700
@@ -128,9 +128,8 @@
 void
 HeCapabilities::Print(std::ostream& os) const
 {
-    os << "HE Capabilities=" << GetHeMacCapabilitiesInfo1() << "|" << +GetHeMacCapabilitiesInfo2()
-       << "|" << GetHePhyCapabilitiesInfo1() << "|" << GetHePhyCapabilitiesInfo2() << "|"
-       << +GetHePhyCapabilitiesInfo3() << "|" << GetSupportedMcsAndNss();
+    os << "HE Capabilities=[Max AMPDU Length Exponent: " << +m_maxAmpduLengthExponent
+       << ", Channel Width Set: " << +m_channelWidthSet << "]";
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.45/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.44/src/wifi/model/he/he-frame-exchange-manager.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-frame-exchange-manager.cc	2025-06-01 20:34:45.616702300 -0700
@@ -334,20 +334,31 @@
 {
     NS_LOG_FUNCTION(this << muRtsSize << muRtsTxVector << txDuration << response);
 
+    WifiTxVector txVector;
+    txVector.SetMode(GetCtsModeAfterMuRts());
+    const auto singleDurationId =
+        VhtFrameExchangeManager::GetRtsDurationId(txVector, txDuration, response);
+
     if (m_edca->GetTxopLimit(m_linkId).IsZero())
     {
-        WifiTxVector txVector;
-        txVector.SetMode(GetCtsModeAfterMuRts());
-        return VhtFrameExchangeManager::GetRtsDurationId(txVector, txDuration, response);
+        return singleDurationId;
     }
 
     // under multiple protection settings, if the TXOP limit is not null, Duration/ID
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(m_edca->GetRemainingTxop(m_linkId) -
-                        WifiPhy::CalculateTxDuration(muRtsSize, muRtsTxVector, m_phy->GetPhyBand()),
-                    Seconds(0));
+    auto duration =
+        std::max(m_edca->GetRemainingTxop(m_linkId) -
+                     WifiPhy::CalculateTxDuration(muRtsSize, muRtsTxVector, m_phy->GetPhyBand()),
+                 Seconds(0));
+
+    if (m_protectSingleExchange)
+    {
+        duration = std::min(duration, singleDurationId + m_singleExchangeProtectionSurplus);
+    }
+
+    return duration;
 }
 
 void
@@ -421,55 +432,10 @@
         return;
     }
 
-    DoCtsAfterMuRtsTimeout(m_psduMap);
+    DoCtsTimeout(m_psduMap);
     m_psduMap.clear();
 }
 
-void
-HeFrameExchangeManager::DoCtsAfterMuRtsTimeout(const WifiPsduMap& psduMap)
-{
-    NS_LOG_FUNCTION(this);
-
-    // GetUpdateCwOnCtsTimeout() needs to be called before resetting m_sentRtsTo
-    const auto updateCw = GetUpdateCwOnCtsTimeout();
-
-    m_sentRtsTo.clear();
-    for (const auto& psdu : psduMap)
-    {
-        for (const auto& mpdu : *PeekPointer(psdu.second))
-        {
-            if (mpdu->IsQueued())
-            {
-                mpdu->ResetInFlight(m_linkId);
-            }
-        }
-    }
-
-    if (const auto& hdr = psduMap.cbegin()->second->GetHeader(0); !hdr.GetAddr1().IsGroup())
-    {
-        GetWifiRemoteStationManager()->ReportRtsFailed(hdr);
-    }
-
-    for (const auto& [staId, psdu] : psduMap)
-    {
-        if (psdu->GetAddr1().IsGroup())
-        {
-            continue;
-        }
-        if (auto droppedMpdu = DropMpduIfRetryLimitReached(psdu))
-        {
-            GetWifiRemoteStationManager()->ReportFinalRtsFailed(droppedMpdu->GetHeader());
-        }
-        // Make the sequence numbers of the MPDUs available again if the MPDUs have never
-        // been transmitted, both in case the MPDUs have been discarded and in case the
-        // MPDUs have to be transmitted (because a new sequence number is assigned to
-        // MPDUs that have never been transmitted and are selected for transmission)
-        ReleaseSequenceNumbers(psdu);
-    }
-
-    TransmissionFailed(!updateCw);
-}
-
 Ptr<WifiPsdu>
 HeFrameExchangeManager::GetPsduTo(Mac48Address to, const WifiPsduMap& psduMap)
 {
@@ -498,7 +464,7 @@
     }
 
     NS_ABORT_MSG_IF(m_psduMap.size() > 1, "RTS/CTS cannot be used to protect an MU PPDU");
-    DoCtsTimeout(m_psduMap.begin()->second);
+    DoCtsTimeout(m_psduMap);
     m_psduMap.clear();
 }
 
@@ -986,11 +952,8 @@
         txVector.SetAggregation(true);
     }
 
-    auto txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, m_phy->GetPhyBand());
-    // The TXNAV timer is a single timer, shared by the EDCAFs within a STA, that is initialized
-    // with the duration from the Duration/ID field in the frame most recently successfully
-    // transmitted by the TXOP holder, except for PS-Poll frames. (Sec.10.23.2.2 IEEE 802.11-2020)
-    m_txNav = Max(m_txNav, Simulator::Now() + txDuration + psduMap.cbegin()->second->GetDuration());
+    const auto txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, m_phy->GetPhyBand());
+    SetTxNav(*psduMap.cbegin()->second->begin(), txDuration);
 
     m_phy->Send(psduMap, txVector);
 }
@@ -1166,7 +1129,13 @@
         std::tie(dlMuTfMuBarAcknowledgment->ulLength, duration) =
             HePhy::ConvertHeTbPpduDurationToLSigLength(duration, txVector, m_phy->GetPhyBand());
 
-        uint32_t muBarSize = GetMuBarSize(dlMuTfMuBarAcknowledgment->barTypes);
+        const auto muBarVariant = (txVector.GetModulationClass() == WIFI_MOD_CLASS_HE)
+                                      ? TriggerFrameVariant::HE
+                                      : TriggerFrameVariant::EHT;
+        uint32_t muBarSize =
+            GetMuBarSize(muBarVariant,
+                         dlMuTfMuBarAcknowledgment->muBarTxVector.GetChannelWidth(),
+                         dlMuTfMuBarAcknowledgment->barTypes);
         if (dlMuTfMuBarAcknowledgment->muBarTxVector.GetModulationClass() >= WIFI_MOD_CLASS_VHT)
         {
             // MU-BAR TF will be sent as an S-MPDU
@@ -1272,11 +1241,15 @@
     {
         bw = MHz_u{80};
     }
-    else
+    else if (ru == 68)
     {
-        NS_ASSERT(ru == 68);
         bw = MHz_u{160};
     }
+    else
+    {
+        NS_ASSERT(ru == 69);
+        bw = MHz_u{320};
+    }
 
     auto txVector = GetWifiRemoteStationManager()->GetCtsTxVector(m_bssid, GetCtsModeAfterMuRts());
     // set the channel width of the CTS TXVECTOR according to the allocated RU
@@ -1307,8 +1280,13 @@
         NS_ASSERT_MSG(!psduInfo->seqNumbers.empty(), "No sequence number for " << receiver);
         const auto tid = psduInfo->seqNumbers.cbegin()->first;
 
+        const auto muBarVariant = (txParams.m_txVector.GetModulationClass() == WIFI_MOD_CLASS_HE)
+                                      ? TriggerFrameVariant::HE
+                                      : TriggerFrameVariant::EHT;
         ppduPayloadSize = MpduAggregator::GetSizeIfAggregated(
-            GetMuBarSize({m_mac->GetBarTypeAsOriginator(receiver, tid)}),
+            GetMuBarSize(muBarVariant,
+                         txParams.m_txVector.GetChannelWidth(),
+                         {m_mac->GetBarTypeAsOriginator(receiver, tid)}),
             ppduPayloadSize);
     }
 
@@ -1585,12 +1563,13 @@
                                                   << m_phy->GetTxPowerEnd() << "dBm)");
     }
     v.SetTxPowerLevel(powerLevel);
-    NS_LOG_LOGIC("UL power control: "
-                 << "input {pathLoss=" << pathLossDb << "dB, reqTxPower=" << reqTxPower << "dBm}"
-                 << " output {powerLevel=" << +powerLevel << " -> " << m_phy->GetPower(powerLevel)
-                 << "dBm}"
-                 << " PHY power capa {min=" << m_phy->GetTxPowerStart() << "dBm, max="
-                 << m_phy->GetTxPowerEnd() << "dBm, levels:" << +numPowerLevels << "}");
+    NS_LOG_LOGIC("UL power control: input "
+                 << "{pathLoss=" << pathLossDb << "dB, reqTxPower=" << reqTxPower << "dBm}"
+                 << " output "
+                 << "{powerLevel=" << +powerLevel << " -> " << m_phy->GetPower(powerLevel) << "dBm}"
+                 << " PHY power capa "
+                 << "{min=" << m_phy->GetTxPowerStart() << "dBm, max=" << m_phy->GetTxPowerEnd()
+                 << "dBm, levels:" << +numPowerLevels << "}");
 
     return v;
 }
@@ -1771,15 +1750,19 @@
      * settings defined in 9.2.5.2. (Sec. 9.2.5.7 of 802.11ax-2021)
      */
     NS_ASSERT(m_edca);
-    if (m_edca->GetTxopLimit(m_linkId).IsZero())
+    const auto singleDurationId = Max(durationId - m_phy->GetSifs() - txDuration, Seconds(0));
+    if (m_edca->GetTxopLimit(m_linkId).IsZero()) // single protection settings
     {
-        // single protection settings
-        psdu->SetDuration(Max(durationId - m_phy->GetSifs() - txDuration, Seconds(0)));
+        psdu->SetDuration(singleDurationId);
     }
-    else
+    else // multiple protection settings
     {
-        // multiple protection settings
-        psdu->SetDuration(Max(m_edca->GetRemainingTxop(m_linkId) - txDuration, Seconds(0)));
+        auto duration = Max(m_edca->GetRemainingTxop(m_linkId) - txDuration, Seconds(0));
+        if (m_protectSingleExchange)
+        {
+            duration = std::min(duration, singleDurationId + m_singleExchangeProtectionSurplus);
+        }
+        psdu->SetDuration(duration);
     }
 
     psdu->GetPayload(0)->AddPacketTag(m_muSnrTag);
@@ -2003,9 +1986,9 @@
 }
 
 bool
-HeFrameExchangeManager::IsIntraBssPpdu(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) const
+HeFrameExchangeManager::IsIntraBssPpdu(const WifiMacHeader& hdr, const WifiTxVector& txVector) const
 {
-    NS_LOG_FUNCTION(this << psdu << txVector);
+    NS_LOG_FUNCTION(this << hdr << txVector);
 
     // "If, based on the MAC address information of a frame carried in a received PPDU, the
     // received PPDU satisfies both intra-BSS and inter-BSS conditions, then the received PPDU is
@@ -2013,9 +1996,9 @@
     // Hence, check first if the intra-BSS conditions using MAC address information are satisfied:
     // 1. "The PPDU carries a frame that has an RA, TA, or BSSID field value that is equal to
     //    the BSSID of the BSS in which the STA is associated"
-    const auto ra = psdu->GetAddr1();
-    const auto ta = psdu->GetAddr2();
-    const auto bssid = psdu->GetHeader(0).GetAddr3();
+    const auto ra = hdr.GetAddr1();
+    auto ta = hdr.GetAddr2();
+    const auto bssid = hdr.GetAddr3();
     const auto empty = Mac48Address();
 
     if (ra == m_bssid || ta == m_bssid || bssid == m_bssid)
@@ -2026,7 +2009,7 @@
     // 2. "The PPDU carries a Control frame that does not have a TA field and that has an
     //    RA field value that matches the saved TXOP holder address of the BSS in which
     //    the STA is associated"
-    if (psdu->GetHeader(0).IsCtl() && ta == empty && ra == m_txopHolder)
+    if (hdr.IsCtl() && ta == empty && ra == m_txopHolder)
     {
         return true;
     }
@@ -2068,16 +2051,18 @@
 }
 
 void
-HeFrameExchangeManager::UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+HeFrameExchangeManager::UpdateNav(const WifiMacHeader& hdr,
+                                  const WifiTxVector& txVector,
+                                  const Time& surplus)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector);
+    NS_LOG_FUNCTION(this << hdr << txVector << surplus.As(Time::US));
 
-    if (!psdu->HasNav())
+    if (!hdr.HasNav())
     {
         return;
     }
 
-    if (psdu->GetAddr1() == m_self)
+    if (hdr.GetAddr1() == m_self)
     {
         // When the received frame's RA is equal to the STA's own MAC address, the STA
         // shall not update its NAV (IEEE 802.11-2020, sec. 10.3.2.4)
@@ -2087,18 +2072,19 @@
     // The intra-BSS NAV is updated by an intra-BSS PPDU. The basic NAV is updated by an
     // inter-BSS PPDU or a PPDU that cannot be classified as intra-BSS or inter-BSS.
     // (Section 26.2.4 of 802.11ax-2021)
-    if (!IsIntraBssPpdu(psdu, txVector))
+    if (!IsIntraBssPpdu(hdr, txVector))
     {
         NS_LOG_DEBUG("PPDU not classified as intra-BSS, update the basic NAV");
-        VhtFrameExchangeManager::UpdateNav(psdu, txVector);
+        VhtFrameExchangeManager::UpdateNav(hdr, txVector, surplus);
         return;
     }
 
     NS_LOG_DEBUG("PPDU classified as intra-BSS, update the intra-BSS NAV");
-    Time duration = psdu->GetDuration();
+    Time duration = hdr.GetDuration();
     NS_LOG_DEBUG("Duration/ID=" << duration);
+    duration += surplus;
 
-    if (psdu->GetHeader(0).IsCfEnd())
+    if (hdr.IsCfEnd())
     {
         // An HE STA that maintains two NAVs (see 26.2.4) and receives a CF-End frame should reset
         // the basic NAV if the received CF-End frame is carried in an inter-BSS PPDU and reset the
@@ -2126,14 +2112,16 @@
         // The “CTS_Time” shall be calculated using the length of the CTS frame and the data
         // rate at which the RTS frame used for the most recent NAV update was received
         // (IEEE 802.11-2016 sec. 10.3.2.4)
-        if (psdu->GetHeader(0).IsRts())
+        if (hdr.IsRts())
         {
+            auto addr2 = hdr.GetAddr2();
             WifiTxVector ctsTxVector =
-                GetWifiRemoteStationManager()->GetCtsTxVector(psdu->GetAddr2(), txVector.GetMode());
+                GetWifiRemoteStationManager()->GetCtsTxVector(addr2, txVector.GetMode());
             auto navResetDelay =
                 2 * m_phy->GetSifs() +
                 WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()) +
                 WifiPhy::CalculatePhyPreambleAndHeaderDuration(ctsTxVector) + 2 * m_phy->GetSlot();
+            m_intraBssNavResetEvent.Cancel();
             m_intraBssNavResetEvent =
                 Simulator::Schedule(navResetDelay,
                                     &HeFrameExchangeManager::IntraBssNavResetTimeout,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-frame-exchange-manager.h ns-3.45/src/wifi/model/he/he-frame-exchange-manager.h
--- ns-3.44/src/wifi/model/he/he-frame-exchange-manager.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-frame-exchange-manager.h	2025-06-01 20:34:45.617702200 -0700
@@ -99,13 +99,13 @@
      * Return whether the received frame is classified as intra-BSS. It is assumed that
      * this station is already associated with an AP.
      *
-     * @param psdu the received PSDU
+     * @param hdr the MAC header of the received PSDU
      * @param txVector TX vector of the received PSDU
      * @return true if the received frame is classified as intra-BSS, false otherwise
      *         (the received frame is classified as inter-BSS or it cannot be classified
      *         as intra-BSS or inter-BSS)
      */
-    bool IsIntraBssPpdu(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) const;
+    bool IsIntraBssPpdu(const WifiMacHeader& hdr, const WifiTxVector& txVector) const;
 
     /**
      * This method is intended to be called a SIFS after the reception of a Trigger Frame
@@ -144,7 +144,9 @@
     void NormalAckTimeout(Ptr<WifiMpdu> mpdu, const WifiTxVector& txVector) override;
     void BlockAckTimeout(Ptr<WifiPsdu> psdu, const WifiTxVector& txVector) override;
     void CtsTimeout(Ptr<WifiMpdu> rts, const WifiTxVector& txVector) override;
-    void UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
+    void UpdateNav(const WifiMacHeader& hdr,
+                   const WifiTxVector& txVector,
+                   const Time& surplus = Time{0}) override;
     void NavResetTimeout() override;
     void StartProtection(const WifiTxParameters& txParams) override;
     void ProtectionCompleted() override;
@@ -192,13 +194,6 @@
     virtual void CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector);
 
     /**
-     * Called when no CTS frame is received after an MU-RTS.
-     *
-     * @param psduMap the PSDU map protected by the failed MU-RTS
-     */
-    void DoCtsAfterMuRtsTimeout(const WifiPsduMap& psduMap);
-
-    /**
      * Send CTS after receiving an MU-RTS.
      *
      * @param muRtsHdr the MAC header of the received MU-RTS
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-operation.cc ns-3.45/src/wifi/model/he/he-operation.cc
--- ns-3.44/src/wifi/model/he/he-operation.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-operation.cc	2025-06-01 20:34:45.617702200 -0700
@@ -33,11 +33,12 @@
 void
 HeOperation::HeOperationParams::Print(std::ostream& os) const
 {
-    os << "Default PE Duration: " << +m_defaultPeDuration << " TWT Required: " << +m_twtRequired
-       << " TXOP Duration RTS Threshold: " << m_txopDurRtsThresh
-       << " VHT Operation Information Present: " << +m_vhOpPresent
-       << " Co-Hosted BSS: " << +m_coHostedBss << " ER SU Disable: " << +m_erSuDisable
-       << " 6 GHz Operation Information Present: " << m_6GHzOpPresent;
+    os << "HE Operation=[Default PE Duration: " << +m_defaultPeDuration
+       << ", TWT Required: " << +m_twtRequired
+       << ", TXOP Duration RTS Threshold: " << m_txopDurRtsThresh
+       << ", VHT Operation Information Present: " << +m_vhOpPresent
+       << ", Co-Hosted BSS: " << +m_coHostedBss << ", ER SU Disable: " << +m_erSuDisable
+       << ", 6 GHz Operation Information Present: " << m_6GHzOpPresent << "]";
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-operation.h ns-3.45/src/wifi/model/he/he-operation.h
--- ns-3.44/src/wifi/model/he/he-operation.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-operation.h	2025-06-01 20:34:45.617702200 -0700
@@ -20,7 +20,7 @@
  * @brief The HE Operation Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise
+ * This class knows how to serialize and deserialize
  * the HE Operation Information Element
  */
 class HeOperation : public WifiInformationElement
